--[[
	
Adds Global Variable CONDITIONAL and node trigger ACTION based on variable value.
This file may be removed from the treescript directory to remove the option from the CONDITIONALS and ACTIONS area.


--]]
local inx, boolval
local oprval
local getval = function(f)
	local v = _G
	for w in string.gfind(f, "[%w_]+") do
		w = tonumber(w) or w
		v = v[w]
	end
	return v
end

    				

local showbool = function(Index,Action,Controls)
	Controls.boolgroup.Visible = true
	Controls.varstring.Visible = false
	Controls.stroperator.Visible = false
	Controls.intoperator.Visible = false
	Controls.alsoifnil.Visible = true
	Controls.vlabel.Visible = false
	Controls.vnamelbl.Visible = true
	Controls.luablock.Visible = false
	Controls.lbllua.Visible = false
	treescript.UpdateDUIPage(Index)
end
local showstr = function(Index,Action,Controls)
	Controls.boolgroup.Visible = false
	Controls.intoperator.Visible = false
	Controls.varstring.Visible = true
	Controls.stroperator.Visible = true
	Controls.alsoifnil.Visible = true
	Controls.vlabel.Visible = true
	Controls.vnamelbl.Visible = true
	Controls.luablock.Visible = false
	Controls.lbllua.Visible = false
	treescript.UpdateDUIPage(Index)
end
local showint = function(Index,Action,Controls)
	Controls.luablock.Visible = false
	Controls.lbllua.Visible = false
	Controls.boolgroup.Visible = false
	Controls.stroperator.Visible = false
	Controls.alsoifnil.Visible = true
	Controls.varstring.Visible = true
	Controls.intoperator.Visible = true
	Controls.vlabel.Visible = true
	Controls.vnamelbl.Visible = true
	oprval = Action.iValue2
	treescript.UpdateDUIPage(Index)
end
local showlua = function(Index,Action,Controls)
	Controls.lbllua.Visible = true
	Controls.luablock.Visible = true
	Controls.vname.Visible = false
	Controls.vnamelbl.Visible = false
	Controls.boolgroup.Visible = false
	Controls.stroperator.Visible = false
	Controls.alsoifnil.Visible = false
	Controls.varstring.Visible = false
	Controls.intoperator.Visible = false
	Controls.vlabel.Visible = false
	treescript.UpdateDUIPage(Index)
end

local showbool2 = function(Index,Action,Controls)
	Controls.boolgroup.Visible = true
	Controls.varstring.Visible = false
	Controls.stroperator.Visible = false
	Controls.intoperator.Visible = false
	treescript.UpdateDUIPage(Index)
end
local showstr2 = function(Index,Action,Controls)
	Controls.boolgroup.Visible = false
	Controls.intoperator.Visible = false
	Controls.varstring.Visible = true
	Controls.stroperator.Visible = true
	treescript.UpdateDUIPage(Index)
end
local showint2 = function(Index,Action,Controls)
	Controls.boolgroup.Visible = false
	Controls.stroperator.Visible = false
	Controls.varstring.Visible = true
	Controls.intoperator.Visible = true
	oprval = Action.iValue2
	treescript.UpdateDUIPage(Index)
end
local showlua2 = function(Index,Action,Controls)
	Controls.boolgroup.Visible = false
	Controls.stroperator.Visible = false
	Controls.varstring.Visible = false
	Controls.intoperator.Visible = false
	treescript.UpdateDUIPage(Index)
end

treescript.Action[110] = {
    OnAction = function(Action, Event)
	local ids = gir.ParseString(Action.sValue3);
	local strids = string.Split(ids, ",");
	local trueID = tonumber(strids[1]);
	local falseID = tonumber(strids[2]);
	local trueFileGUID = strids[3];
	local falseFileGUID = strids[4];
	oprval = tonumber(Action.iValue2)
	Action.iValue1 = Action.iValue1 or nil
    	if Action.iValue1 ~= nil then    		
    		if Action.iValue1 == 'string' then
    			Action.sValue1 = Action.sValue1 or nil
    			if Action.sValue1 ~= nil then
    				if oprval == 0 then
    					local v = getval(Action.sValue1)
	  				if v==Action.sValue2 then
    						gir.TriggerNode(trueFileGUID, trueID, true);
      					else
      						gir.TriggerNode(falseFileGUID, falseID, true);
      					end
    				elseif oprval == 1 then
    					local v = getval(Action.sValue1)
	  				if v ~=Action.sValue2 then
    						gir.TriggerNode(trueFileGUID, trueID, true);
      					else
      						gir.TriggerNode(falseFileGUID, falseID, true);
      					end
    				end
    			end 
    		elseif Action.iValue1 == 'bool' then
    			if Action.sValue1 ~= nil then
    				if oprval == 0 then tmp = true else tmp = false end
    				local v =getval(Action.sValue1)
    				if v ~= nil and v==tmp then
    					gir.TriggerNode(trueFileGUID, trueID, true);
    				else
    					gir.TriggerNode(falseFileGUID, falseID, true);
    				end
    			end
    		elseif Action.iValue1 == 'int' then
    			if Action.sValue1 ~= nil and Action.iValue3 ~= nil then
    				local v = getval(Action.sValue1)
      				if oprval == 0 and v ~= nil then
      					if v == tonumber(Action.iValue3) then
      						gir.TriggerNode(trueFileGUID, trueID, true);
      					else
      						gir.TriggerNode(falseFileGUID, falseID, true);
      					end
      				elseif oprval == 1 and v ~= nil  then
      					if v > tonumber(Action.iValue3) then
      						gir.TriggerNode(trueFileGUID, trueID, true);
      					else
      						gir.TriggerNode(falseFileGUID, falseID, true);
      					end
				elseif oprval == 2 and v ~= nil then
      					if v < tonumber(Action.iValue3) then
      						gir.TriggerNode(trueFileGUID, trueID, true);
      					else
      						gir.TriggerNode(falseFileGUID, falseID, true);
      					end     					
				elseif oprval == 3 and v ~= nil then
      					if v >= tonumber(Action.iValue3) then
      						gir.TriggerNode(trueFileGUID, trueID, true);
      					else
      						gir.TriggerNode(falseFileGUID, falseID, true);
      					end
				elseif oprval == 4 and v ~= nil then
      					if v <= tonumber(Action.iValue3) then
      						gir.TriggerNode(trueFileGUID, trueID, true);
      					else
      						gir.TriggerNode(falseFileGUID, falseID, true);
      					end
   				end
    			end
    		end  	
    	end    	
end,
  
    OnDefaults=function (Index, Action)
        Action.sValue3 = "0,0,0,0";
    end,
    
    
    OnShow = function (Index, Action, Controls)
    	inx = Index
	    	if Action.iValue1 == 'bool' then
	    		showbool2(Index,Action,Controls)
	    		oprval = tonumber(Action.iValue2)
	    		Controls.boolgroup.ItemIndex = oprval
	    	elseif Action.iValue1 == 'string' then
			showstr2(Index,Action,Controls)
			oprval = tonumber(Action.iValue2)
			Controls.stroperator.ItemIndex = oprval
			Controls.varstring.Text = Action.sValue2
		elseif Action.iValue1 == 'int' then
			showint2(Index,Action,Controls)
			oprval = tonumber(Action.iValue2)
			Controls.intoperator.ItemIndex = oprval
			Controls.varstring.Text = tonumber(Action.sValue2)
			Action.iValue3 = tonumber(Controls.varstring.Text)
		elseif Action.iValue1 == 'lua' then
			showlua2(Index,Action,Controls)
		else
			--new setup, assume string
			showstr2(Index,Action,Controls)
		end
		local ids = gir.ParseString(Action.sValue3);
		local strids = string.Split(ids, ",");
		Controls.jumptrue.ID = tonumber(strids[1]);
		Controls.jumpfalse.ID = tonumber(strids[2]);
		Controls.jumptrue.FileGUID = strids[3];
		Controls.jumpfalse.FileGUID = strids[4];
		treescript.UpdateDUIPage(Index)	
    end,
    
    OnApply = function (Index, Action, Controls)
    	if Action.iValue1 == 'int' then
    		Action.sValue2 = tonumber(Controls.varstring.Text)
    		Action.iValue2 = tonumber(Controls.intoperator.ItemIndex)
    		Action.iValue3 = tonumber(Controls.varstring.Text)
    	elseif Action.iValue1 == 'bool' then
    	    	Action.sValue2 = tonumber(Controls.varstring.Text)
    		Action.iValue2 = tonumber(Controls.boolgroup.ItemIndex)
    	else
    		Action.iValue2 = tonumber(Controls.stroperator.ItemIndex)
    		Action.sValue2 = Controls.varstring.Text
    	end    	
    		Action.sValue3 = string.format("%s,%s,%s,%s",Controls.jumptrue.ID,Controls.jumpfalse.ID,Controls.jumptrue.FileGUID,Controls.jumpfalse.FileGUID)
    end,

    OnEvent = function (Index, Action, Controls,Control, ID1, ID2)
	    if ID1 == 1 then
	    	if Action.iValue1 == 'bool' then
	    		Controls.boolgroup.Visible = true
	    		Controls.varstring.Visible = false
	    		Controls.stroperator.Visible = false
	    		Controls.intoperator.Visible = false
	    		Controls.boolgroup.ItemIndex = boolval
	    	elseif Action.iValue1 == 'string' then
			Controls.boolgroup.Visible = false
			Controls.varstring.Visible = true
			Controls.stroperator.Visible = true
			Controls.intoperator.Visible = false
			Controls.varstring.Text = Action.sValue2
		elseif Action.iValue1 == 'int' then
			Controls.boolgroup.Visible = false
			Controls.varstring.Visible = true
			Controls.stroperator.Visible = false
			Controls.intoperator.Visible = true
			Action.iValue3 = tonumber(Action.sValue2)
			Controls.varstring.Text = tonumber(Action.sValue2)
		elseif Action.iValue1 == 'lua' then
			Controls.boolgroup.Visible = false
			Controls.varstring.Visible = false
			Controls.stroperator.Visible = false
			Controls.intoperator.Visible = false
		end
			treescript.UpdateDUIPage(Index)
	    end
	
	    if ID1 == 2 then
	    	operator = Controls.boolgroup.ItemIndex
	    	Action.iValue2= operator
	    	oprval = operator
	    end
	    if ID1 == 3 then
	    	operator = Controls.stroperator.ItemIndex
	    	Action.iValue2= operator
	    	oprval = operator
	    end
	    if ID1 == 4 then
	    	operator = Controls.intoperator.ItemIndex
	    	Action.iValue2= operator
	    	oprval = operator
	    end	    
    end,
    
    OnClose = function (Index, Action, Controls)
    end,
}


treescript.Conditional[110] = {
    OnAction = function(Action, Event)
    	oprval = tonumber(Action.iValue2)
    	if Action.iValue1 ~= nil then    
    		if Action.iValue1 == 'string' then
    			if Action.sValue1 ~= nil then
    				if oprval == 0 then
    					local v = getval(Action.sValue1)
    					if v == nil then
    						if Action.bValue1 == '-1' then
    							return true
    						end
    					end
	  				if v==Action.sValue2 then
    						return true
    					end
    				elseif oprval == 1 then
    					local v = getval(Action.sValue1)
    					if v == nil then
    						if Action.bValue1 == '-1' then
    							return true
    						end
    					end    					
	  				if v ~=Action.sValue2 then
    						return true
    					end
    				end
    			end 
    		elseif Action.iValue1 == 'bool' then
    			if Action.sValue1 ~= nil then
    				if oprval == 0 then tmp = true else tmp = false end
    				local v =getval(Action.sValue1)
    				    	if v == nil then
    						if Action.bValue1 == '-1' then
    							return true
    						end
    					end
    				if v ~= nil and v==tmp then
    					return true
    				end
    			end
    		elseif Action.iValue1 == 'int' then
    			if Action.sValue1 ~= nil and Action.iValue3 ~= nil then
    				local v = getval(Action.sValue1)
    				    	if v == nil then
    						if Action.bValue1 == '-1' then
    							return true
    						end
    					end
      				if oprval == 0 and v ~= nil then
      					if v == tonumber(Action.iValue3) then
      						return true
      					end
      				elseif oprval == 1 and v ~= nil  then
      					if v > tonumber(Action.iValue3) then
      						return true
      					end
				elseif oprval == 2 and v ~= nil then
      					if v < tonumber(Action.iValue3) then
      						return true
      					end     					
				elseif oprval == 3 and v ~= nil then
      					if v >= tonumber(Action.iValue3) then
      						return true
      					end
				elseif oprval == 4 and v ~= nil then
      					if v <= tonumber(Action.iValue3) then
      						return true
      					end
   				end
    			end
    		elseif Action.iValue1 == 'lua' then
    			if Action.sValue1 ~= nil then
		    		local result = assert(loadstring("return "..Action.sValue1))()
		      		if (result == true) then return true else return false end	
    			else
    				return false
    			end
    		else
    			return false
    		end  	
    	else
    		return false
    	end  
	return false
    end,
  
  
    OnDefaults = function(Index, Action)
    end,
    
    
    OnShow = function (Index, Action, Controls)
    	inx = Index   	
	    	if Action.iValue1 == 'bool' then
	    		showbool(Index,Action,Controls)
	    		oprval = tonumber(Action.iValue2)
	    		Controls.boolgroup.ItemIndex = oprval
	    		Controls.vname.Text = Action.sValue1
	    		if Action.bValue1 == '-1' then
	    			Controls.alsoifnil.Checked = true
	    		else
	    			Controls.alsoifnil.Checked = false
	    		end
	    	elseif Action.iValue1 == 'lua' then
			showlua(Index,Action,Controls)
			Controls.luablock.Text = Action.sValue1	
	    	elseif Action.iValue1 == 'string' then
			showstr(Index,Action,Controls)
			oprval = tonumber(Action.iValue2)
			Controls.stroperator.ItemIndex = oprval
			Controls.varstring.Text = Action.sValue2
			Controls.vname.Text = Action.sValue1
			if Action.bValue1 == '-1' then
	    			Controls.alsoifnil.Checked = true
	    		else
	    			Controls.alsoifnil.Checked = false
	    		end 
		elseif Action.iValue1 == 'int' then
			showint(Index,Action,Controls)
			oprval = tonumber(Action.iValue2)
			Controls.intoperator.ItemIndex = oprval
			Controls.varstring.Text = tonumber(Action.sValue2)
			Action.iValue3 = tonumber(Controls.varstring.Text)
			Controls.vname.Text = Action.sValue1
			if Action.bValue1 == '-1' then
	    			Controls.alsoifnil.Checked = true
	    		else
	    			Controls.alsoifnil.Checked = false
	    		end	    		
		else
			--new setup, assume string
			showstr(Index,Action,Controls)
		end
		treescript.UpdateDUIPage(Index)	
    end,
    
    OnApply = function (Index, Action, Controls)
    	if Action.iValue1 == 'int' then
    		Action.sValue2 = tonumber(Controls.varstring.Text)
    		Action.iValue2 = tonumber(Controls.intoperator.ItemIndex)
    		Action.iValue3 = tonumber(Controls.varstring.Text)
    		Action.sValue1 = Controls.vname.Text
    		if Controls.alsoifnil.Checked then
    			Action.bValue1 = '-1'
    		else
    			Action.bValue1 = '0'
    		end
    		
    	elseif Action.iValue1 == 'bool' then
    	    	Action.sValue2 = tonumber(Controls.varstring.Text)
    		Action.iValue2 = tonumber(Controls.boolgroup.ItemIndex)
    		Action.sValue1 = Controls.vname.Text
    		if Controls.alsoifnil.Checked then
    			Action.bValue1 = '-1'
    		else
    			Action.bValue1 = '0'
    		end
    	elseif Action.iValue1 == 'lua' then
    		Action.sValue1 = Controls.luablock.Text
    	else
    		Action.sValue1 = Controls.vname.Text
    		Action.sValue2 = Controls.varstring.Text
    		Action.iValue2 = tonumber(Controls.stroperator.ItemIndex)
    		if Controls.alsoifnil.Checked then
    			Action.bValue1 = '-1'
    		else
    			Action.bValue1 = '0'
    		end
    	end
    end,

    
    OnEvent = function (Index, Action, Controls,Control, ID1, ID2)
	    if ID1 == 1 then
	    	if Action.iValue1 == 'bool' then
	    		Controls.vname.Visible = true
	    		Controls.vnamelbl.Visible = true
	    		Controls.vname.Text = Action.sValue1
	    		Controls.luablock.Visible = false
	    		Controls.lbllua.Visible = false
	    		Controls.boolgroup.Visible = true
	    		Controls.alsoifnil.Visible = true
	    		Controls.varstring.Visible = false
	    		Controls.stroperator.Visible = false
	    		Controls.intoperator.Visible = false
	    		Controls.vlabel.Visible = false
	    		Controls.boolgroup.ItemIndex = boolval
	    	elseif Action.iValue1 == 'string' then
	    		Controls.vname.Visible = true
	    		Controls.vnamelbl.Visible = true
	    		Controls.vname.Text = Action.sValue1
	    		Controls.luablock.Visible = false
	    		Controls.lbllua.Visible = false
	    		Controls.alsoifnil.Visible = true
			Controls.boolgroup.Visible = false
			Controls.varstring.Visible = true
			Controls.stroperator.Visible = true
			Controls.intoperator.Visible = false
			Controls.vlabel.Visible = true
			Controls.stroperator.ItemIndex = tonumber(Action.iValue2)
			Controls.varstring.Text = Action.sValue2
		elseif Action.iValue1 == 'int' then
			Controls.vname.Visible = true
			Controls.vnamelbl.Visible = true
			Controls.vname.Text = Action.sValue1		
			Controls.luablock.Visible = false
			Controls.lbllua.Visible = false
			Controls.boolgroup.Visible = false
			Controls.alsoifnil.Visible = true
			Controls.varstring.Visible = true
			Controls.stroperator.Visible = false
			Controls.intoperator.Visible = true
			Controls.vlabel.Visible = true
			Action.iValue3 = tonumber(Action.sValue2)
			Controls.varstring.Text = tonumber(Action.sValue2)
		elseif Action.iValue1 == 'lua' then
			Controls.vname.Visible = false
			Controls.vnamelbl.Visible = false
			Controls.luablock.Visible = true
			Controls.alsoifnil.Visible = false
			Controls.lbllua.Visible = true
		end
			treescript.UpdateDUIPage(Index)
	    end
	
	    if ID1 == 2 then
	    	operator = Controls.boolgroup.ItemIndex
	    	Action.iValue2= operator
	    	oprval = operator
	    end
	    if ID1 == 3 then
	    	operator = Controls.stroperator.ItemIndex
	    	Action.iValue2= operator
	    	oprval = operator
	    end
	    if ID1 == 4 then
	    	operator = Controls.intoperator.ItemIndex
	    	Action.iValue2= operator
	    	oprval = operator
	    end	    
    end,
    
    OnClose = function (Index, Action, Controls)
    end,
}

return "Variable.xml"